// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from naoqi_bridge_msgs:msg/RobotInfo.idl
// generated code does not contain a copyright notice

#ifndef NAOQI_BRIDGE_MSGS__MSG__DETAIL__ROBOT_INFO__TRAITS_HPP_
#define NAOQI_BRIDGE_MSGS__MSG__DETAIL__ROBOT_INFO__TRAITS_HPP_

#include "naoqi_bridge_msgs/msg/detail/robot_info__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const naoqi_bridge_msgs::msg::RobotInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: model
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "model: ";
    value_to_yaml(msg.model, out);
    out << "\n";
  }

  // member: head_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "head_version: ";
    value_to_yaml(msg.head_version, out);
    out << "\n";
  }

  // member: body_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "body_version: ";
    value_to_yaml(msg.body_version, out);
    out << "\n";
  }

  // member: arm_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "arm_version: ";
    value_to_yaml(msg.arm_version, out);
    out << "\n";
  }

  // member: has_laser
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "has_laser: ";
    value_to_yaml(msg.has_laser, out);
    out << "\n";
  }

  // member: has_extended_arms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "has_extended_arms: ";
    value_to_yaml(msg.has_extended_arms, out);
    out << "\n";
  }

  // member: number_of_legs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_legs: ";
    value_to_yaml(msg.number_of_legs, out);
    out << "\n";
  }

  // member: number_of_arms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_arms: ";
    value_to_yaml(msg.number_of_arms, out);
    out << "\n";
  }

  // member: number_of_hands
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_hands: ";
    value_to_yaml(msg.number_of_hands, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const naoqi_bridge_msgs::msg::RobotInfo & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<naoqi_bridge_msgs::msg::RobotInfo>()
{
  return "naoqi_bridge_msgs::msg::RobotInfo";
}

template<>
inline const char * name<naoqi_bridge_msgs::msg::RobotInfo>()
{
  return "naoqi_bridge_msgs/msg/RobotInfo";
}

template<>
struct has_fixed_size<naoqi_bridge_msgs::msg::RobotInfo>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<naoqi_bridge_msgs::msg::RobotInfo>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<naoqi_bridge_msgs::msg::RobotInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NAOQI_BRIDGE_MSGS__MSG__DETAIL__ROBOT_INFO__TRAITS_HPP_
